#pragma once

// This class provides an IDocHostUIHandlerDispatch* object for the IE.
// It's required e.g. to disable the IE's context menu
class CMyDocHostHandler
{
public:
    inline CMyDocHostHandler()
    {
        ASSERT( NULL == s_pThis, "Attempting to construct more then one instance of CMyDocHostHandler object" );
        s_pThis = this;
    }
    inline ~CMyDocHostHandler()
    {
        ASSERT( NULL != s_pThis, "STG_E_UNKNOWN" );
        s_pThis = NULL;
    }

    static IDocHostUIHandlerDispatch* GetDocHostHandler();
private:
    CComPtr<IDocHostUIHandlerDispatch> m_pDoc;
    static CMyDocHostHandler* s_pThis;
};
