#pragma once
#include "../VsTabs/TabViewImpl.hpp"

// A simple view window encapsulating the MS Internet Explorer ActiveX control.
// TODO: when using this control not for file:// or res:// but for http://, make the contained window live in its own thread.
class CIeViewWnd:
	public NVsTabs::CTabViewWindowImpl< CIeViewWnd >
{
public:
	CIeViewWnd( NVsTabs::CTabsOwner* pOwner );
	virtual ~CIeViewWnd();

	HRESULT Create( CWindow* pParent );

	DECLARE_WND_CLASS( L"IeView" );

	BEGIN_MSG_MAP( CIeViewWnd )
		CHAIN_MSG_MAP( TTabViewImpl )
		MESSAGE_HANDLER( WM_CREATE,   OnCreate )
		MESSAGE_HANDLER( WM_SIZE,     OnSize )
		MESSAGE_HANDLER( WM_SETFOCUS, OnSetFocus )
	END_MSG_MAP()
private:

	LRESULT OnCreate( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnSize( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
	LRESULT OnSetFocus( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );

	CAxWindow m_ie;
};