#pragma once

// This interface must be implemented by the tab's owner, to receive notifications
__interface IVSTabsHost
{
    // Called when the tab is switched
    void OnTabSwitched( DWORD dwTabID );

    // Called when the user right-clicks on a tab's caption.
    void OnTabContextMenu( DWORD dwTabID, CPoint pt );

    // Called when the user clicks on the "close" button.
    void OnTabClose( DWORD dwTabID );
};
